
#ifndef _HARDWARE_PROFILE_H
#define _HARDWARE_PROFILE_H

#define GetSystemClock()      (40000000ul)  
#define GetInstructionClock() (GetSystemClock()/4)
#define GetPeripheralClock()  GetInstructionClock()

// ENC28J60 IO Mappings

// use RB0-RB2 (INT0-INT2) for the interrupt pins

#define ENC_INT_TRIS_0    (TRISBbits.TRISB0)
#define ENC_INT_IO_0      (LATBbits.LATB0)

#define ENC_INT_TRIS_1    (TRISBbits.TRISB1)
#define ENC_INT_IO_1      (LATBbits.LATB1)

#define ENC_INT_TRIS_2    (TRISBbits.TRISB2)
#define ENC_INT_IO_2      (LATBbits.LATB2)

// Reset

#define ENC_RST_TRIS_0		(TRISCbits.TRISC6)
#define ENC_RST_IO_0	  	(LATCbits.LATC6) 
	
#define ENC_RST_TRIS_1    (TRISCbits.TRISC7)
#define ENC_RST_IO_1	  	(LATCbits.LATC7) 	

#define ENC_RST_TRIS_2    (TRISDbits.TRISD7)
#define ENC_RST_IO_2	  	(LATDbits.LATD7) 	

// carier select CS

#define ENC_CS_TRIS_0			(TRISDbits.TRISD4)	
#define ENC_CS_IO_0		    (LATDbits.LATD4)

#define ENC_CS_TRIS_1			(TRISDbits.TRISD5)	
#define ENC_CS_IO_1		    (LATDbits.LATD5)

#define ENC_CS_TRIS_2			(TRISDbits.TRISD6)	
#define ENC_CS_IO_2		    (LATDbits.LATD6)

// SPI

#define ENC_SCK_TRIS		(TRISCbits.TRISC3)
#define ENC_SDI_TRIS		(TRISCbits.TRISC4)
#define ENC_SDO_TRIS		(TRISCbits.TRISC5)	

// ENC28J60 Registers

#define ENC_SPI_IF			(PIR1bits.SSPIF)
#define ENC_SSPBUF			(SSPBUF)
#define ENC_SPISTAT			(SSPSTAT)
#define ENC_SPISTATbits	(SSPSTATbits)
#define ENC_SPICON1			(SSPCON1)
#define ENC_SPICON1bits	(SSPCON1bits)
#define ENC_SPICON2			(SSPCON2)

			


#endif
