package FW::Interface;

use strict;

use base qw(FW::Base);

use FW::CIDR;

sub new
  {
    my $pkg = shift;
    my $number = shift;
 
    my $obj = $pkg->SUPER::new();
    $obj->{'INTERFACE'} = $number; 
    $obj->{'MAC'} = 0;
    $obj->{'IP'} = '';
    $obj->{'NET'} = '';
    $obj->{'MASK'} = '';
    $obj->{'BITS'} = '';

    bless $obj, $pkg;

    return $obj;
  }

sub getNet
  {
    my $obj = shift;
    return $obj->{'NET'};
  }

sub getMask
  {
    my $obj = shift;
    return $obj->{'MASK'};
  }

sub getInterface
  {
    my $obj = shift;
    return $obj->{'INTERFACE'};
  }

sub setIP
  {
    my $obj = shift;
    my $addr = shift;

    my ($ip) = ($addr =~ /(\d+\.\d+\.\d+\.\d+)\/\d+/);
    $obj->{'IP'} = $ip;

    my ($net,$mask,$bits) = FW::CIDR::cidr_reduce($addr);

    $obj->{'BITS'} = $bits;
    $obj->{'NET'}  = $net;
    $obj->{'MASK'} = $mask;
  }

sub setMAC
  {
    my $obj = shift;
    my $addr = shift;

    my ($mac) = ($addr =~ /(\S\S:\S\S:\S\S:\S\S:\S\S:\S\S)/);
    $obj->{'MAC'} = $mac;
  }


sub toString
  {
    # return hex where first 4 bytes are IP, next 4 are mask and last 6 are MAC
    my $obj = shift;

    my @ret = ();

    push(@ret, $obj->toHex( split(/\./,$obj->{'IP'})   ));
    push(@ret, $obj->toHex( split(/\./,$obj->{'MASK'}) ));

    push(@ret, split(/:/,$obj->{'MAC'}));

    return join(" ",@ret);
  }

return 1;
