package FW::Port;

use strict;

use base qw(FW::Base);

sub new
  {
    my $pkg = shift;
    my $text = shift;
 
    my $obj = $pkg->SUPER::new($text);
    $obj->{'ANY'} = 0;
    $obj->{'NUMBER'} = 0;

    bless $obj, $pkg;

    $obj->expand($text) if ($text);

    return $obj;
  }

sub getAny
  {
    my $obj = shift;
    return $obj->{'ANY'};
  }

sub setAny
  {
    my $obj = shift;
    $obj->{'ANY'} = shift;
  }

sub getNumber
  {
    my $obj = shift;
    return $obj->{'NUMBER'};
  }

sub setNumber
  {
    my $obj = shift;
    $obj->{'NUMBER'} = shift;
  }

sub expand
  {
    my $obj = shift;
    my $port = shift;

    my $any = 0;
    my $value = 0;

    if ($port eq 'any')
      {
        $obj->setAny(1);
      }
    elsif ($port =~ /(\d+)/)
      {
        $obj->setNumber($1);
      }
    else
      {
        die "Cannot determine port format";
      }

    $obj->setHex( sprintf("%.2x %.2x",int($value/256), ($value % 256)) );
    $obj->setHexLen( 2 );
  }

return 1;

